// line 1 "ext/redcloth_scan/redcloth_attributes.java.rl"
/*
 * redcloth_attributes.rl
 *
 * Copyright (C) 2009 Jason Garber
 */
import java.io.IOException;

import org.jruby.Ruby;
import org.jruby.RubyArray;
import org.jruby.RubyClass;
import org.jruby.RubyHash;
import org.jruby.RubyModule;
import org.jruby.RubyNumeric;
import org.jruby.RubyObject;
import org.jruby.RubyString;
import org.jruby.RubySymbol;
import org.jruby.anno.JRubyMethod;
import org.jruby.runtime.Block;
import org.jruby.runtime.CallbackFactory;
import org.jruby.runtime.builtin.IRubyObject;
import org.jruby.exceptions.RaiseException;
import org.jruby.runtime.load.BasicLibraryService;

import org.jruby.util.ByteList;

public class RedclothAttributes extends RedclothScanService.Base {

// line 34 "ext/redcloth_scan/redcloth_attributes.java.rl"



// line 34 "ext/redcloth_scan/RedclothAttributes.java"
private static byte[] init__redcloth_attributes_actions_0()
{
	return new byte [] {
	    0,    1,    2,    1,    4,    1,    5,    1,    6,    1,    7,    1,
	    8,    1,   11,    1,   12,    1,   13,    1,   15,    1,   18,    1,
	   19,    2,    3,   14,    2,   10,   17,    2,   13,    0,    2,   13,
	    1,    2,   13,    2,    2,   13,    5,    2,   13,    6,    2,   13,
	    7,    2,   13,    8,    3,    9,   10,   16
	};
}

private static final byte _redcloth_attributes_actions[] = init__redcloth_attributes_actions_0();


private static short[] init__redcloth_attributes_key_offsets_0()
{
	return new short [] {
	    0,    0,    6,   11,   27,   33,   38,   44,   60,   66,   87,  108,
	  118,  129,  137,  146,  153,  159,  164,  180,  201,  205,  210,  224,
	  240,  257,  274,  291,  304,  318,  325,  331,  346,  360,  375,  385,
	  391,  406,  420,  435,  445,  452,  462,  473,  492,  513,  535,  557,
	  579,  598,  618,  634,  650,  660,  671,  690,  711,  733,  755,  777,
	  796,  816,  819,  825,  840,  854,  869,  878,  888,  899,  918,  939,
	  961,  983, 1005, 1024, 1044
	};
}

private static final short _redcloth_attributes_key_offsets[] = init__redcloth_attributes_key_offsets_0();


private static char[] init__redcloth_attributes_trans_keys_0()
{
	return new char [] {
	    0,    9,   10,   32,   11,   13,    0,    9,   32,   10,   13,    0,
	    9,   10,   32,   35,   41,   45,   95,   11,   13,   48,   57,   65,
	   90,   97,  122,    0,    9,   10,   32,   11,   13,    0,    9,   32,
	   10,   13,    0,    9,   10,   32,   11,   13,    0,    9,   10,   32,
	   35,   41,   45,   95,   11,   13,   48,   57,   65,   90,   97,  122,
	    0,    9,   10,   32,   11,   13,    0,    9,   10,   32,   95,  117,
	  125,   11,   13,   34,   35,   37,   39,   45,   46,   48,   59,   65,
	   90,   97,  122,    0,    9,   10,   32,   95,  117,  125,   11,   13,
	   34,   35,   37,   39,   45,   46,   48,   59,   65,   90,   97,  122,
	   32,   35,   45,   95,   48,   57,   65,   90,   97,  122,   32,   35,
	   41,   45,   95,   48,   57,   65,   90,   97,  122,   45,   95,   48,
	   57,   65,   90,   97,  122,   41,   45,   95,   48,   57,   65,   90,
	   97,  122,    0,   32,   40,   91,  123,    9,   13,    0,    9,   10,
	   32,   11,   13,    0,    9,   32,   10,   13,    0,    9,   10,   32,
	   35,   41,   45,   95,   11,   13,   48,   57,   65,   90,   97,  122,
	    0,    9,   10,   32,   95,  117,  125,   11,   13,   34,   35,   37,
	   39,   45,   46,   48,   59,   65,   90,   97,  122,   45,   95,   97,
	  122,   45,   93,   95,   97,  122,   32,   95,   34,   35,   37,   39,
	   45,   46,   48,   59,   65,   90,   97,  122,   32,   95,  117,  125,
	   34,   35,   37,   39,   45,   46,   48,   59,   65,   90,   97,  122,
	   32,   95,  114,  117,  125,   34,   35,   37,   39,   45,   46,   48,
	   59,   65,   90,   97,  122,   32,   95,  108,  117,  125,   34,   35,
	   37,   39,   45,   46,   48,   59,   65,   90,   97,  122,   32,   40,
	   95,  117,  125,   34,   35,   37,   39,   45,   46,   48,   59,   65,
	   90,   97,  122,   39,   43,   61,   92,   95,   34,   35,   45,   57,
	   63,   64,   97,  122,   39,   41,   43,   61,   92,   95,   34,   35,
	   45,   57,   63,   64,   97,  122,    0,   32,   40,   91,  123,    9,
	   13,    0,    9,   10,   32,   11,   13,    0,    9,   10,   32,   35,
	   45,   95,   11,   13,   48,   57,   65,   90,   97,  122,    0,    9,
	   10,   32,   45,   95,   11,   13,   48,   57,   65,   90,   97,  122,
	    0,    9,   10,   32,   41,   45,   95,   11,   13,   48,   57,   65,
	   90,   97,  122,    0,    9,   10,   32,   40,   46,   91,  123,   11,
	   13,    0,    9,   10,   32,   11,   13,    0,    9,   10,   32,   35,
	   45,   95,   11,   13,   48,   57,   65,   90,   97,  122,    0,    9,
	   10,   32,   45,   95,   11,   13,   48,   57,   65,   90,   97,  122,
	    0,    9,   10,   32,   41,   45,   95,   11,   13,   48,   57,   65,
	   90,   97,  122,    0,    9,   10,   32,   40,   46,   91,  123,   11,
	   13,    0,    9,   10,   32,   46,   11,   13,    0,    9,   10,   32,
	   45,   95,   11,   13,   97,  122,    0,    9,   10,   32,   45,   93,
	   95,   11,   13,   97,  122,    0,    9,   10,   32,   95,   11,   13,
	   34,   35,   37,   39,   45,   46,   48,   59,   65,   90,   97,  122,
	    0,    9,   10,   32,   95,  117,  125,   11,   13,   34,   35,   37,
	   39,   45,   46,   48,   59,   65,   90,   97,  122,    0,    9,   10,
	   32,   95,  114,  117,  125,   11,   13,   34,   35,   37,   39,   45,
	   46,   48,   59,   65,   90,   97,  122,    0,    9,   10,   32,   95,
	  108,  117,  125,   11,   13,   34,   35,   37,   39,   45,   46,   48,
	   59,   65,   90,   97,  122,    0,    9,   10,   32,   40,   95,  117,
	  125,   11,   13,   34,   35,   37,   39,   45,   46,   48,   59,   65,
	   90,   97,  122,    0,    9,   10,   32,   39,   43,   61,   92,   95,
	   11,   13,   34,   35,   45,   57,   63,   64,   97,  122,    0,    9,
	   10,   32,   39,   41,   43,   61,   92,   95,   11,   13,   34,   35,
	   45,   57,   63,   64,   97,  122,    0,    9,   10,   32,   35,   41,
	   45,   95,   11,   13,   48,   57,   65,   90,   97,  122,    0,    9,
	   10,   32,   35,   41,   45,   95,   11,   13,   48,   57,   65,   90,
	   97,  122,    0,    9,   10,   32,   45,   95,   11,   13,   97,  122,
	    0,    9,   10,   32,   45,   93,   95,   11,   13,   97,  122,    0,
	    9,   10,   32,   95,   11,   13,   34,   35,   37,   39,   45,   46,
	   48,   59,   65,   90,   97,  122,    0,    9,   10,   32,   95,  117,
	  125,   11,   13,   34,   35,   37,   39,   45,   46,   48,   59,   65,
	   90,   97,  122,    0,    9,   10,   32,   95,  114,  117,  125,   11,
	   13,   34,   35,   37,   39,   45,   46,   48,   59,   65,   90,   97,
	  122,    0,    9,   10,   32,   95,  108,  117,  125,   11,   13,   34,
	   35,   37,   39,   45,   46,   48,   59,   65,   90,   97,  122,    0,
	    9,   10,   32,   40,   95,  117,  125,   11,   13,   34,   35,   37,
	   39,   45,   46,   48,   59,   65,   90,   97,  122,    0,    9,   10,
	   32,   39,   43,   61,   92,   95,   11,   13,   34,   35,   45,   57,
	   63,   64,   97,  122,    0,    9,   10,   32,   39,   41,   43,   61,
	   92,   95,   11,   13,   34,   35,   45,   57,   63,   64,   97,  122,
	   40,   91,  123,    0,    9,   10,   32,   11,   13,    0,    9,   10,
	   32,   35,   45,   95,   11,   13,   48,   57,   65,   90,   97,  122,
	    0,    9,   10,   32,   45,   95,   11,   13,   48,   57,   65,   90,
	   97,  122,    0,    9,   10,   32,   41,   45,   95,   11,   13,   48,
	   57,   65,   90,   97,  122,    0,    9,   10,   32,   40,   91,  123,
	   11,   13,    0,    9,   10,   32,   45,   95,   11,   13,   97,  122,
	    0,    9,   10,   32,   45,   93,   95,   11,   13,   97,  122,    0,
	    9,   10,   32,   95,   11,   13,   34,   35,   37,   39,   45,   46,
	   48,   59,   65,   90,   97,  122,    0,    9,   10,   32,   95,  117,
	  125,   11,   13,   34,   35,   37,   39,   45,   46,   48,   59,   65,
	   90,   97,  122,    0,    9,   10,   32,   95,  114,  117,  125,   11,
	   13,   34,   35,   37,   39,   45,   46,   48,   59,   65,   90,   97,
	  122,    0,    9,   10,   32,   95,  108,  117,  125,   11,   13,   34,
	   35,   37,   39,   45,   46,   48,   59,   65,   90,   97,  122,    0,
	    9,   10,   32,   40,   95,  117,  125,   11,   13,   34,   35,   37,
	   39,   45,   46,   48,   59,   65,   90,   97,  122,    0,    9,   10,
	   32,   39,   43,   61,   92,   95,   11,   13,   34,   35,   45,   57,
	   63,   64,   97,  122,    0,    9,   10,   32,   39,   41,   43,   61,
	   92,   95,   11,   13,   34,   35,   45,   57,   63,   64,   97,  122,
	    0,    9,   10,   32,   35,   41,   45,   95,   11,   13,   48,   57,
	   65,   90,   97,  122,    0
	};
}

private static final char _redcloth_attributes_trans_keys[] = init__redcloth_attributes_trans_keys_0();


private static byte[] init__redcloth_attributes_single_lengths_0()
{
	return new byte [] {
	    0,    4,    3,    8,    4,    3,    4,    8,    4,    7,    7,    4,
	    5,    2,    3,    5,    4,    3,    8,    7,    2,    3,    2,    4,
	    5,    5,    5,    5,    6,    5,    4,    7,    6,    7,    8,    4,
	    7,    6,    7,    8,    5,    6,    7,    5,    7,    8,    8,    8,
	    9,   10,    8,    8,    6,    7,    5,    7,    8,    8,    8,    9,
	   10,    3,    4,    7,    6,    7,    7,    6,    7,    5,    7,    8,
	    8,    8,    9,   10,    8
	};
}

private static final byte _redcloth_attributes_single_lengths[] = init__redcloth_attributes_single_lengths_0();


private static byte[] init__redcloth_attributes_range_lengths_0()
{
	return new byte [] {
	    0,    1,    1,    4,    1,    1,    1,    4,    1,    7,    7,    3,
	    3,    3,    3,    1,    1,    1,    4,    7,    1,    1,    6,    6,
	    6,    6,    6,    4,    4,    1,    1,    4,    4,    4,    1,    1,
	    4,    4,    4,    1,    1,    2,    2,    7,    7,    7,    7,    7,
	    5,    5,    4,    4,    2,    2,    7,    7,    7,    7,    7,    5,
	    5,    0,    1,    4,    4,    4,    1,    2,    2,    7,    7,    7,
	    7,    7,    5,    5,    4
	};
}

private static final byte _redcloth_attributes_range_lengths[] = init__redcloth_attributes_range_lengths_0();


private static short[] init__redcloth_attributes_index_offsets_0()
{
	return new short [] {
	    0,    0,    6,   11,   24,   30,   35,   41,   54,   60,   75,   90,
	   98,  107,  113,  120,  127,  133,  138,  151,  166,  170,  175,  184,
	  195,  207,  219,  231,  241,  252,  259,  265,  277,  288,  300,  310,
	  316,  328,  339,  351,  361,  368,  377,  387,  400,  415,  431,  447,
	  463,  478,  494,  507,  520,  529,  539,  552,  567,  583,  599,  615,
	  630,  646,  650,  656,  668,  679,  691,  700,  709,  719,  732,  747,
	  763,  779,  795,  810,  826
	};
}

private static final short _redcloth_attributes_index_offsets[] = init__redcloth_attributes_index_offsets_0();


private static byte[] init__redcloth_attributes_indicies_0()
{
	return new byte [] {
	    0,    2,    3,    2,    0,    1,    0,    2,    2,    0,    1,    0,
	    2,    3,    4,    5,    6,    7,    7,    0,    7,    7,    7,    1,
	    8,   10,   11,   10,    8,    9,    8,   10,   10,    8,    9,    0,
	    2,    3,   13,    0,   12,    8,   10,   11,   14,   15,   16,   17,
	   17,    8,   17,   17,   17,    9,    8,   10,   11,   18,    8,   12,
	    8,   10,   11,   19,   20,   21,   22,    8,   20,   20,   20,   20,
	   20,   20,    9,    0,    2,    3,   23,   24,   25,   26,    0,   24,
	   24,   24,   24,   24,   24,    1,   27,   29,   27,   27,   27,   27,
	   27,   28,   30,   31,   32,   30,   30,   30,   30,   30,   28,   33,
	   33,   33,   33,   33,   28,   34,   35,   35,   35,   35,   35,   28,
	   28,   28,   37,   38,   39,   28,   36,   40,   42,   43,   42,   40,
	   41,   40,   42,   42,   40,   41,   40,   42,   43,   44,   45,   46,
	   47,   47,   40,   47,   47,   47,   41,   40,   42,   43,   48,   49,
	   50,   51,   40,   49,   49,   49,   49,   49,   49,   41,   52,   52,
	   52,   28,   53,   54,   53,   53,   28,   55,   55,   55,   55,   55,
	   55,   55,   55,   28,   56,   56,   57,   58,   56,   56,   56,   56,
	   56,   56,   28,   56,   56,   59,   57,   58,   56,   56,   56,   56,
	   56,   56,   28,   56,   56,   60,   57,   58,   56,   56,   56,   56,
	   56,   56,   28,   56,   61,   56,   57,   58,   56,   56,   56,   56,
	   56,   56,   28,   62,   62,   62,   62,   62,   62,   62,   62,   62,
	   28,   62,   56,   62,   62,   62,   62,   62,   62,   62,   62,   28,
	   28,   28,   64,   65,   66,   28,   63,   67,    2,    3,    2,   67,
	    1,   67,    2,    3,   68,   69,   70,   70,   67,   70,   70,   70,
	    1,   67,    2,    3,    2,   71,   71,   67,   71,   71,   71,    1,
	   67,    2,    3,    2,   72,   73,   73,   67,   73,   73,   73,    1,
	   67,    2,    3,   13,   74,   75,   76,   77,   67,   12,   78,   10,
	   11,   10,   78,    9,   78,   10,   11,   79,   80,   81,   81,   78,
	   81,   81,   81,    9,   78,   10,   11,   10,   82,   82,   78,   82,
	   82,   82,    9,   78,   10,   11,   10,   83,   84,   84,   78,   84,
	   84,   84,    9,   78,   10,   11,   18,   74,   75,   76,   77,   78,
	   12,   78,   10,   11,   18,   75,   78,   12,   78,   10,   11,   10,
	   85,   85,   78,   85,    9,   78,   10,   11,   10,   86,   87,   86,
	   78,   86,    9,   78,   10,   11,   88,   89,   78,   89,   89,   89,
	   89,   89,   89,    9,   78,   10,   11,   19,   20,   21,   22,   78,
	   20,   20,   20,   20,   20,   20,    9,   78,   10,   11,   19,   20,
	   90,   21,   22,   78,   20,   20,   20,   20,   20,   20,    9,   78,
	   10,   11,   19,   20,   91,   21,   22,   78,   20,   20,   20,   20,
	   20,   20,    9,   78,   10,   11,   19,   92,   20,   21,   22,   78,
	   20,   20,   20,   20,   20,   20,    9,   78,   10,   11,   10,   93,
	   93,   93,   93,   93,   78,   93,   93,   93,   93,    9,   78,   10,
	   11,   10,   93,   20,   93,   93,   93,   93,   78,   93,   93,   93,
	   93,    9,   78,   10,   11,   14,   15,   16,   17,   17,   78,   17,
	   17,   17,    9,   67,    2,    3,    4,    5,    6,    7,    7,   67,
	    7,    7,    7,    1,   67,    2,    3,    2,   94,   94,   67,   94,
	    1,   67,    2,    3,    2,   95,   96,   95,   67,   95,    1,   67,
	    2,    3,   97,   98,   67,   98,   98,   98,   98,   98,   98,    1,
	   67,    2,    3,   23,   24,   25,   26,   67,   24,   24,   24,   24,
	   24,   24,    1,   67,    2,    3,   23,   24,   99,   25,   26,   67,
	   24,   24,   24,   24,   24,   24,    1,   67,    2,    3,   23,   24,
	  100,   25,   26,   67,   24,   24,   24,   24,   24,   24,    1,   67,
	    2,    3,   23,  101,   24,   25,   26,   67,   24,   24,   24,   24,
	   24,   24,    1,   67,    2,    3,    2,  102,  102,  102,  102,  102,
	   67,  102,  102,  102,  102,    1,   67,    2,    3,    2,  102,   24,
	  102,  102,  102,  102,   67,  102,  102,  102,  102,    1,  103,  104,
	  105,   28,  106,   42,   43,   42,  106,   41,  106,   42,   43,  107,
	  108,  109,  109,  106,  109,  109,  109,   41,  106,   42,   43,   42,
	  110,  110,  106,  110,  110,  110,   41,  106,   42,   43,   42,  111,
	  112,  112,  106,  112,  112,  112,   41,  106,   42,   43,   42,   37,
	   38,   39,  106,   36,  106,   42,   43,   42,  113,  113,  106,  113,
	   41,  106,   42,   43,   42,  114,  115,  114,  106,  114,   41,  106,
	   42,   43,  116,  117,  106,  117,  117,  117,  117,  117,  117,   41,
	  106,   42,   43,   48,   49,   50,   51,  106,   49,   49,   49,   49,
	   49,   49,   41,  106,   42,   43,   48,   49,  118,   50,   51,  106,
	   49,   49,   49,   49,   49,   49,   41,  106,   42,   43,   48,   49,
	  119,   50,   51,  106,   49,   49,   49,   49,   49,   49,   41,  106,
	   42,   43,   48,  120,   49,   50,   51,  106,   49,   49,   49,   49,
	   49,   49,   41,  106,   42,   43,   42,  121,  121,  121,  121,  121,
	  106,  121,  121,  121,  121,   41,  106,   42,   43,   42,  121,   49,
	  121,  121,  121,  121,  106,  121,  121,  121,  121,   41,  106,   42,
	   43,   44,   45,   46,   47,   47,  106,   47,   47,   47,   41,    0
	};
}

private static final byte _redcloth_attributes_indicies[] = init__redcloth_attributes_indicies_0();


private static byte[] init__redcloth_attributes_trans_targs_0()
{
	return new byte [] {
	   29,   30,    1,    2,    3,   32,   34,   51,   29,   35,    4,    5,
	   35,    6,    7,   37,   39,   50,    8,    9,   44,   45,   39,   10,
	   55,   56,   34,   12,    0,   13,   12,   13,   15,   14,   15,   14,
	   62,   63,   67,   69,   61,   62,   16,   17,   18,   64,   66,   76,
	   19,   70,   71,   66,   21,   21,   15,   23,   23,   24,   15,   25,
	   26,   27,   28,   30,   31,   52,   54,   29,    3,   32,   51,   33,
	   34,   33,   36,   40,   41,   43,   29,    7,   37,   50,   38,   39,
	   38,   42,   42,   39,    9,   44,   46,   47,   48,   49,   53,   53,
	   34,   10,   55,   57,   58,   59,   60,   11,   20,   22,   61,   18,
	   64,   76,   65,   66,   65,   68,   68,   66,   19,   70,   72,   73,
	   74,   75
	};
}

private static final byte _redcloth_attributes_trans_targs[] = init__redcloth_attributes_trans_targs_0();


private static byte[] init__redcloth_attributes_trans_actions_0()
{
	return new byte [] {
	   23,   17,    0,    0,    0,   40,   40,   17,   21,   17,    0,    0,
	   31,    0,    0,   40,   40,   17,    0,    0,   17,   17,   49,    0,
	   17,   17,   49,    1,    0,    0,    0,    5,    5,    1,    7,    0,
	   31,   31,   31,   31,   19,   17,    0,    0,    0,   40,   40,   17,
	    0,   17,   17,   49,    1,    0,    9,    1,    0,    0,   11,    0,
	    0,    0,    0,   34,   34,   34,   34,   28,    1,   17,   37,   37,
	   43,   17,   31,   31,   31,   31,   52,    1,   17,   37,   37,   43,
	   17,   37,   17,   46,    1,   37,   17,   17,   17,   17,   37,   17,
	   46,    1,   37,   17,   17,   17,   17,    3,    3,    3,   25,    1,
	   17,   37,   37,   43,   17,   37,   17,   46,    1,   37,   17,   17,
	   17,   17
	};
}

private static final byte _redcloth_attributes_trans_actions[] = init__redcloth_attributes_trans_actions_0();


private static byte[] init__redcloth_attributes_to_state_actions_0()
{
	return new byte [] {
	    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
	    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
	    0,    0,    0,    0,    0,   13,    0,    0,    0,    0,    0,    0,
	    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
	    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
	    0,   13,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
	    0,    0,    0,    0,    0
	};
}

private static final byte _redcloth_attributes_to_state_actions[] = init__redcloth_attributes_to_state_actions_0();


private static byte[] init__redcloth_attributes_from_state_actions_0()
{
	return new byte [] {
	    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
	    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
	    0,    0,    0,    0,    0,   15,    0,    0,    0,    0,    0,    0,
	    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
	    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
	    0,   15,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
	    0,    0,    0,    0,    0
	};
}

private static final byte _redcloth_attributes_from_state_actions[] = init__redcloth_attributes_from_state_actions_0();


private static short[] init__redcloth_attributes_eof_trans_0()
{
	return new short [] {
	    0,    1,    1,    1,    9,    9,    1,    9,    9,    9,    1,    0,
	    0,    0,    0,    0,   41,   41,   41,   41,    0,    0,    0,    0,
	    0,    0,    0,    0,    0,    0,   68,   68,   68,   68,   68,   79,
	   79,   79,   79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
	   79,   79,   79,   68,   68,   68,   68,   68,   68,   68,   68,   68,
	   68,    0,  107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
	  107,  107,  107,  107,  107
	};
}

private static final short _redcloth_attributes_eof_trans[] = init__redcloth_attributes_eof_trans_0();


static final int redcloth_attributes_start = 29;
static final int redcloth_attributes_error = 0;

static final int redcloth_attributes_en_inline = 61;
static final int redcloth_attributes_en_link_says = 29;

// line 37 "ext/redcloth_scan/redcloth_attributes.java.rl"

  private int machine;
   
  public RedclothAttributes(int machine, IRubyObject self, byte[] data, int p, int pe) {
    this.runtime = self.getRuntime();
    this.self = self;

    // This is GROSS but necessary for EOF matching
    this.data = new byte[pe+1];
    System.arraycopy(data, p, this.data, 0, pe);
    this.data[pe] = 0;

    this.p = 0;
    this.pe = pe+1;
    this.eof = this.pe;
    this.orig_p = 0;
    this.orig_pe = this.pe;

    this.regs = RubyHash.newHash(runtime);
    this.attr_regs = RubyHash.newHash(runtime);
    this.machine = machine;
  }

  public IRubyObject parse() {
    
// line 410 "ext/redcloth_scan/RedclothAttributes.java"
	{
	cs = redcloth_attributes_start;
	ts = -1;
	te = -1;
	act = 0;
	}
// line 62 "ext/redcloth_scan/redcloth_attributes.java.rl"
  
    cs = machine;

    
// line 422 "ext/redcloth_scan/RedclothAttributes.java"
	{
	int _klen;
	int _trans = 0;
	int _acts;
	int _nacts;
	int _keys;
	int _goto_targ = 0;

	_goto: while (true) {
	switch ( _goto_targ ) {
	case 0:
	if ( p == pe ) {
		_goto_targ = 4;
		continue _goto;
	}
	if ( cs == 0 ) {
		_goto_targ = 5;
		continue _goto;
	}
case 1:
	_acts = _redcloth_attributes_from_state_actions[cs];
	_nacts = (int) _redcloth_attributes_actions[_acts++];
	while ( _nacts-- > 0 ) {
		switch ( _redcloth_attributes_actions[_acts++] ) {
	case 12:
// line 1 "ext/redcloth_scan/redcloth_attributes.java.rl"
	{ts = p;}
	break;
// line 451 "ext/redcloth_scan/RedclothAttributes.java"
		}
	}

	_match: do {
	_keys = _redcloth_attributes_key_offsets[cs];
	_trans = _redcloth_attributes_index_offsets[cs];
	_klen = _redcloth_attributes_single_lengths[cs];
	if ( _klen > 0 ) {
		int _lower = _keys;
		int _mid;
		int _upper = _keys + _klen - 1;
		while (true) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( data[p] < _redcloth_attributes_trans_keys[_mid] )
				_upper = _mid - 1;
			else if ( data[p] > _redcloth_attributes_trans_keys[_mid] )
				_lower = _mid + 1;
			else {
				_trans += (_mid - _keys);
				break _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _redcloth_attributes_range_lengths[cs];
	if ( _klen > 0 ) {
		int _lower = _keys;
		int _mid;
		int _upper = _keys + (_klen<<1) - 2;
		while (true) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( data[p] < _redcloth_attributes_trans_keys[_mid] )
				_upper = _mid - 2;
			else if ( data[p] > _redcloth_attributes_trans_keys[_mid+1] )
				_lower = _mid + 2;
			else {
				_trans += ((_mid - _keys)>>1);
				break _match;
			}
		}
		_trans += _klen;
	}
	} while (false);

	_trans = _redcloth_attributes_indicies[_trans];
case 3:
	cs = _redcloth_attributes_trans_targs[_trans];

	if ( _redcloth_attributes_trans_actions[_trans] != 0 ) {
		_acts = _redcloth_attributes_trans_actions[_trans];
		_nacts = (int) _redcloth_attributes_actions[_acts++];
		while ( _nacts-- > 0 )
	{
			switch ( _redcloth_attributes_actions[_acts++] )
			{
	case 0:
// line 5 "ext/redcloth_scan/redcloth_attributes.java.rl"
	{ MARK(); }
	break;
	case 1:
// line 6 "ext/redcloth_scan/redcloth_attributes.java.rl"
	{ MARK_B(); }
	break;
	case 2:
// line 7 "ext/redcloth_scan/redcloth_attributes.java.rl"
	{ MARK_ATTR(); }
	break;
	case 3:
// line 9 "ext/redcloth_scan/redcloth_attributes.java.rl"
	{ STORE("text"); }
	break;
	case 4:
// line 10 "ext/redcloth_scan/redcloth_attributes.java.rl"
	{ CLEAR_REGS(); RESET_REG(); }
	break;
	case 5:
// line 35 "ext/redcloth_scan/redcloth_attributes.java.rl"
	{ STORE_ATTR("class"); }
	break;
	case 6:
// line 36 "ext/redcloth_scan/redcloth_attributes.java.rl"
	{ STORE_ATTR("id"); }
	break;
	case 7:
// line 38 "ext/redcloth_scan/redcloth_attributes.java.rl"
	{ STORE_ATTR("lang"); }
	break;
	case 8:
// line 39 "ext/redcloth_scan/redcloth_attributes.java.rl"
	{ STORE_ATTR("style"); }
	break;
	case 9:
// line 20 "ext/redcloth_scan/redcloth_attributes.java.rl"
	{ STORE("name"); }
	break;
	case 10:
// line 21 "ext/redcloth_scan/redcloth_attributes.java.rl"
	{ STORE_B("name_without_attributes"); }
	break;
	case 13:
// line 1 "ext/redcloth_scan/redcloth_attributes.java.rl"
	{te = p+1;}
	break;
	case 14:
// line 16 "ext/redcloth_scan/redcloth_attributes.java.rl"
	{te = p;p--;{ SET_ATTRIBUTES(); }}
	break;
	case 15:
// line 16 "ext/redcloth_scan/redcloth_attributes.java.rl"
	{{p = ((te))-1;}{ SET_ATTRIBUTES(); }}
	break;
	case 16:
// line 25 "ext/redcloth_scan/redcloth_attributes.java.rl"
	{te = p;p--;{ SET_ATTRIBUTES(); }}
	break;
	case 17:
// line 26 "ext/redcloth_scan/redcloth_attributes.java.rl"
	{te = p;p--;{ SET_ATTRIBUTE("name_without_attributes", "name"); }}
	break;
	case 18:
// line 25 "ext/redcloth_scan/redcloth_attributes.java.rl"
	{{p = ((te))-1;}{ SET_ATTRIBUTES(); }}
	break;
	case 19:
// line 26 "ext/redcloth_scan/redcloth_attributes.java.rl"
	{{p = ((te))-1;}{ SET_ATTRIBUTE("name_without_attributes", "name"); }}
	break;
// line 587 "ext/redcloth_scan/RedclothAttributes.java"
			}
		}
	}

case 2:
	_acts = _redcloth_attributes_to_state_actions[cs];
	_nacts = (int) _redcloth_attributes_actions[_acts++];
	while ( _nacts-- > 0 ) {
		switch ( _redcloth_attributes_actions[_acts++] ) {
	case 11:
// line 1 "ext/redcloth_scan/redcloth_attributes.java.rl"
	{ts = -1;}
	break;
// line 601 "ext/redcloth_scan/RedclothAttributes.java"
		}
	}

	if ( cs == 0 ) {
		_goto_targ = 5;
		continue _goto;
	}
	if ( ++p != pe ) {
		_goto_targ = 1;
		continue _goto;
	}
case 4:
	if ( p == eof )
	{
	if ( _redcloth_attributes_eof_trans[cs] > 0 ) {
		_trans = _redcloth_attributes_eof_trans[cs] - 1;
		_goto_targ = 3;
		continue _goto;
	}
	}

case 5:
	}
	break; }
	}
// line 66 "ext/redcloth_scan/redcloth_attributes.java.rl"

    return regs;
  }

  public static IRubyObject attributes(IRubyObject self, IRubyObject str) {
    ByteList bl = str.convertToString().getByteList();
    int cs = redcloth_attributes_en_inline;
    return new RedclothAttributes(cs, self, bl.bytes, bl.begin, bl.realSize).parse();
  }

  public static IRubyObject link_attributes(IRubyObject self, IRubyObject str) {
    Ruby runtime = self.getRuntime();

    ByteList bl = str.convertToString().getByteList();
    int cs = redcloth_attributes_en_link_says;
    return new RedclothAttributes(cs, self, bl.bytes, bl.begin, bl.realSize).parse();
  }
}
